# for reading image.version0.82.bits.html data

import sys

class K:
    def __init__(self, row):
        self.row = row
        self.index = row[2]
        self.classnum = row[0]
        self.instvars = []
        self.instances = []
        i = 1
        while type(row[i + 1]) is int:
            self.instvars.append((row[i], row[i+1]))
            i = i + 2
        self.humanname = row[i + 1]
        i = i + 2
        if i >= len(row):
            return
        numinsts = self.row[i]
        i = i + 1
        if numinsts == -1:
            self.instances.append('special' + self.humanname)
        else:
            if self.humanname in ['Array', 'Method']:
                self.parsearrays(i)
            elif self.humanname == 'Char':
                self.parsechars(i)
            else:
                self.parsebytes(i)
            if len(self.instances) != numinsts:
                print 'eek', len(self.instances), numinsts, self.humanname

    def parsearrays(self, i):
        while i < len(self.row):
            instlen = self.row[i]
            if instlen == -1:
                break
            i = i + 1
            pointers = self.row[i : i + instlen]
            inst = []
            x = 0
            while x < len(pointers):
                inst.append((pointers[x], pointers[x+1]))
                x = x + 2
            i = i + instlen
            self.instances.append(inst)

    def parsechars(self, i):
        while i < len(self.row):
            c = self.row[i]
            if c == -1:
                break
            self.instances.append('char' + chr(c))
            i = i + 1

    def parsebytes(self, i):
        while i < len(self.row):
            instlen = self.row[i]
            if instlen == -1:
                break
            i = i + 1
            inst = self.row[i : i + instlen]
            if self.humanname == 'String':
                inst = ''.join(chr(x) for x in inst)
            i = i + instlen
            self.instances.append(inst)

    def resolve(self, resolver):
        self.classobj = resolver(self.classnum)
        self.instvars = [resolver(t) for t in self.instvars]
        if self.humanname in ['Array', 'Method']:
            for inst in self.instances:
                for i in range(len(inst)):
                    inst[i] = resolver(inst[i])

    def check(self):
        if len(self.instvars) != self.classobj.instvars[3]:
            print 'eek'
            print self.humanname, len(self.instvars), self.classobj.humanname, self.classobj.instvars[3]
            print self.instvars
            print self.classobj.instvars

def load(f):
    lines = [line.strip().split() for line in f.readlines()]
    for row in lines:
        for i in range(len(row)):
            try:
                row[i] = int(row[i])
            except ValueError:
                pass

    specials = lines[0]

    o = []
    for row in lines[1:]:
        o.append(K(row))

    def resolver(t):
        print t
        if type(t) is int:
            return o[t - 1]
        else:
            (c, i) = t
            if c == 0:
                return i
            elif c == specials[8]:
                return 'smallint' + str(i)
            else:
                return o[c - 1].instances[i - 1]

    for v in o:
        o[v.classnum - 1].instances.append(v)

    for v in o:
        v.resolve(resolver)

    for v in o:
        v.check()

    return o

def r():
    f = file('image.version0.82.bits.csv')
    o = load(f)
    f.close()
    return o
